/*
 * generated by Xtext
 */
package at.ac.univie.cs.swa.component.architectureabstraction.formatting

import at.ac.univie.cs.swa.component.architectureabstraction.services.ArchitectureAbstractionDSLGrammarAccess
import com.google.inject.Inject
import java.util.LinkedList
import java.util.List
import org.eclipse.emf.ecore.EObject
import org.eclipse.xtext.Keyword
import org.eclipse.xtext.RuleCall
import org.eclipse.xtext.formatting.impl.AbstractDeclarativeFormatter
import org.eclipse.xtext.formatting.impl.FormattingConfig
import org.eclipse.xtext.util.Pair

// import com.google.inject.Inject;
// import at.ac.univie.cs.swa.component.architectureabstraction.services.ArchitectureAbstractionDSLGrammarAccess
/**
 * This class contains custom formatting description.
 * 
 * see : http://www.eclipse.org/Xtext/documentation.html#formatting
 * on how and when to use it 
 * 
 * Also see {@link org.eclipse.xtext.xtext.XtextFormattingTokenSerializer} as an example
 */
class ArchitectureAbstractionDSLFormatter extends AbstractDeclarativeFormatter {

	@Inject extension ArchitectureAbstractionDSLGrammarAccess

	override protected void configureFormatting(FormattingConfig c) {

		// It's usually a good idea to activate the following three statements.
		// They will add and preserve newlines around comments
		//		c.setLinewrap(0, 1, 2).before(SL_COMMENTRule)
		//		c.setLinewrap(0, 1, 2).before(ML_COMMENTRule)
		//		c.setLinewrap(0, 1, 1).after(ML_COMMENTRule)
		//		ArchitectureAbstractionDSLGrammarAccess f = getGrammarAccess();
		c.setAutoLinewrap(120);

		// find common keywords an specify formatting for them
		val List<Pair<Keyword, Keyword>> keywordList = findKeywordPairs("(", ")")
		for (Pair<Keyword, Keyword> pair : keywordList) {
			if (!getPrimaryAccess().getLeftCurlyBracketKeyword_3_0().equals(pair.first)) {
				c.setNoSpace().after(pair.getFirst());
				c.setNoSpace().before(pair.getSecond());
			}
		}
		for (Keyword comma : findKeywords(",")) {
			c.setNoSpace().before(comma);
		}

		c.setLinewrap().around(getPrimaryAccess().getLeftCurlyBracketKeyword_3_0());
		c.setLinewrap().around(getPrimaryAccess().getRightCurlyBracketKeyword_3_2());

		// format source brackets
		// c.setIndentationDecrement().before(f.getPrimaryAccess().getRightCurlyBracketKeyword_3_2());
		// c.setIndentationDecrement().before(f.getComponentAccess().getRightCurlyBracketKeyword_6());
		// c.setIndentationDecrement().before(f.getComponentAccess().getRightCurlyBracketKeyword_7_4());
		// c.setIndentationDecrement().after(f.getComponentAccess().getRightCurlyBracketKeyword_6());
		// c.setIndentationDecrement().after(f.getComponentAccess().getRightCurlyBracketKeyword_7_4());
		// c.setIndentationIncrement().before(f.getComponentAccess().getSourceKeyword_3());
		// c.setIndentationIncrement().before(f.getComponentAccess().getPrimitivesKeyword_7_0());
		c.setLinewrap(2).before(getComponentDefAccess().getComponentKeyword_0());

		c.setLinewrap().before(getComponentDefAccess().getConsistsOfKeyword_2());

		// c.setIndentationDecrement().before(f.getComponentAccess().getComponentKeyword_0());
		for (Keyword keyword : findKeywords("or", "and", "and not", "}")) {
			c.setLinewrap().around(keyword);
		}
		{
			val List<EObject> nospacelist = new LinkedList<EObject>();

			// nospacelist.add(f.getComponentAccess().getNameAssignment_1());
			nospacelist.add(getContainedInPackageAccess().getRelatedToAssignment_2());
			nospacelist.add(getSupertypeAccess().getRelatedToAssignment_2());
			nospacelist.add(getInstanceOfAccess().getRelatedToAssignment_2());
			nospacelist.add(getJavaExtensionFilterAccess().getStaticMethodAssignment_2());
			nospacelist.add(getXtendExtensionFilterAccess().getFunctionAssignment_2());
			nospacelist.add(getUsedByFilterAccess().getRelatedToAssignment_2());
			nospacelist.add(getUsesFilterAccess().getRelatedToAssignment_2());
			nospacelist.add(getChildOfFilterAccess().getRelatedToAssignment_2());
			nospacelist.add(getClassNameFilterAccess().getRegExAssignment_2());
			nospacelist.add(getPackageNameFilterAccess().getRegExAssignment_2());

			for (EObject eObj : nospacelist) {
				c.setNoSpace().around(eObj);
			}
		}

		// formatting for Comments
		c.setLinewrap(0, 1, 2).before(getSL_COMMENTRule());
		c.setLinewrap(0, 1, 2).before(getML_COMMENTRule());
		c.setLinewrap(0, 1, 1).after(getML_COMMENTRule());

		c.setIndentationIncrement().after(getPrimaryAccess().getLeftCurlyBracketKeyword_3_0());
		c.setIndentationDecrement().before(getPrimaryAccess().getRightCurlyBracketKeyword_3_2());
		c.setIndentationIncrement().after(getComponentDefAccess().getNameAssignment_1());
		c.setIndentationDecrement().after(getComponentDefAccess().getExprOrCompositionParserRuleCall_3_0());

		// c.setIndentationIncrement().before(
		// f.getComponentAccess().getIsKeyword_4_0());
		// TODO reinsert
		c.setIndentationIncrement().before(getComponentDefAccess().connectorsComponentConnectorParserRuleCall_5_0);
		c.setIndentationDecrement().after(getComponentDefAccess().connectorsComponentConnectorParserRuleCall_5_0);
		c.setIndentationIncrement().before(componentConnectorAccess.implementedByKeyword_2_0)
		c.setIndentationDecrement().after(componentConnectorAccess.implementedByKeyword_2_0)
//		c.setIndentationIncrement().before(
//			componentConnectorAccess.implementingExpressionOrCompositionParserRuleCall_2_1_0)
		c.setIndentationIncrement().before(
			componentConnectorAccess.implementingExpressionOrCompositionParserRuleCall_2_1_0)
//		c.setIndentationDecrement().after(
//			componentConnectorAccess.implementingExpressionOrCompositionParserRuleCall_2_1_0)
		c.setIndentationDecrement().after(
			componentConnectorAccess.implementingExpressionOrCompositionParserRuleCall_2_1_0)
		c.setIndentationIncrement().before(componentAnnotationAccess.rule);
		c.setIndentationDecrement().after(componentAnnotationAccess.rule);
			
		c.setLinewrap(1, 1, 1).before(componentAnnotationAccess.rule);
//		c.setLinewrap(1, 1, 1).after(componentDefAccess.consistsOfKeyword_2);		
		c.setLinewrap(1, 1, 1).before(componentConnectorAccess.implementedByKeyword_2_0);
		c.setLinewrap(1, 1, 1).after(componentConnectorAccess.implementedByKeyword_2_0);
		c.setLinewrap(1, 1, 1).before(componentConnectorAccess.annotationAssignment_1);
		for (RuleCall r : findRuleCalls(componentConnectorRule)) {
			c.setLinewrap(1, 1, 2).after(r);
		}

	}
}
