package at.ac.univie.cs.swa.component.architectureabstraction.test.unit

import at.ac.univie.cs.swa.component.architectureabstraction.ArchitectureAbstractionDSLInjectorProvider
import com.google.inject.Inject
import org.eclipse.xtext.junit4.InjectWith
import org.eclipse.xtext.junit4.XtextRunner
import org.eclipse.xtext.junit4.util.ParseHelper
import org.junit.Test
import org.junit.runner.RunWith
import at.ac.univie.cs.swa.component.architectureabstraction.architectureAbstractionDSL.Transformation

import static org.junit.Assert.*

@RunWith(typeof(XtextRunner))
@InjectWith(typeof(ArchitectureAbstractionDSLInjectorProvider))
class SimpleTests {

	@Inject ParseHelper<Transformation> parser

	@Test
	def void simplePositiveTest() {
	    val model = parser.parse('
"test"
import "testimport"
export "testexport"
			Component("test") {
	Package(root.mdd.dsl)	
}
		')
		val resource = model.eResource

		assertTrue( resource.errors.size == 0)
		assertTrue( resource.warnings.size == 0 )
		
		for(error : resource.errors) {
			println(error)
		}
		
		for(warning : resource.warnings) {
			println(warning)
		}
	}

}