/*
* generated by Xtext
*/
package at.ac.univie.cs.swa.component.architectureabstraction.ui.quickfix

import at.ac.univie.cs.swa.component.architectureabstraction.architectureAbstractionDSL.NameFilter
import java.io.IOException
import java.util.Arrays
import java.util.Collections
import java.util.List
import org.eclipse.emf.common.util.URI
//import org.eclipse.emf.compare.util.ModelUtils
import org.eclipse.emf.ecore.EObject
import org.eclipse.emf.ecore.resource.Resource
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl
import org.eclipse.xtext.ui.editor.quickfix.DefaultQuickfixProvider
import org.eclipse.xtext.ui.editor.quickfix.Fix
import org.eclipse.xtext.ui.editor.quickfix.IssueResolutionAcceptor
import org.eclipse.xtext.validation.Issue
import at.ac.univie.cs.swa.component.architectureabstraction.validation.ArchitectureAbstractionDSLValidator


/**
 * Custom quickfixes.
 *
 * see http://www.eclipse.org/Xtext/documentation.html#quickfixes
 */
class ArchitectureAbstractionDSLQuickfixProvider extends DefaultQuickfixProvider {

//	@Fix(MyDslValidator::INVALID_NAME)
//	def capitalizeName(Issue issue, IssueResolutionAcceptor acceptor) {
//		acceptor.accept(issue, 'Capitalize name', 'Capitalize the name.', 'upcase.png') [
//			context |
//			val xtextDocument = context.xtextDocument
//			val firstLetter = xtextDocument.get(issue.offset, 1)
//			xtextDocument.replace(issue.offset, 1, firstLetter.toUpperCase)
//		]
//	}

	@Fix(ArchitectureAbstractionDSLValidator::NO_OBJECTS_REFERENCED)
	def public void createReference(Issue issue,
			IssueResolutionAcceptor acceptor) {
		acceptor.accept(issue, "Change relation element to parent",
				"Automatically select a parent as relation element.",
				"upcase.png", new SemanticReferenceModification());
	}

	@Fix(ArchitectureAbstractionDSLValidator::UNUSED_CLASSIFIERS)
	def public void useMoreClasses(Issue issue,
			IssueResolutionAcceptor acceptor) {
		val String[] dataArray = issue.getData();

		val List<String> asList = Arrays::asList(dataArray);
		Collections::sort(asList);
		var String oldPackageString = "";
		
		var int counter = 0;
		for (String data : asList) {
			val String packageString = getPackageString(data);
			if (oldPackageString.equals(packageString)) {
				counter = counter+1;
			} else {
//				createSuggestionsForNewCompoment(packageString,oldPackageString,acceptor,issue);
				createSuggestionForNewComponent(issue, acceptor,
						oldPackageString, counter);
				oldPackageString = packageString;
				counter = 0;
			}

			// System.out.println(data);
		}
		createSuggestionForNewComponent(issue, acceptor, oldPackageString, counter);
	}

	def private void createSuggestionForNewComponent(Issue issue,
			IssueResolutionAcceptor acceptor, String oldPackageString,
			int counter) {
		if (counter > 3) {
			val String componentName = getComponentName(oldPackageString);
			val String fullQualifiedPackage = oldPackageString
					.replace("::", ".");
			acceptor.accept(issue, "Create new component: "
					+ componentName, "Create a new component "
					+ " for package:" + fullQualifiedPackage,
					"upcase.png", new NewComponentModification(fullQualifiedPackage));
		}
	}

	def private String getComponentName(String oldPackageString) {
		var int lastIndexOfColon = oldPackageString.lastIndexOf(":");
		if (lastIndexOfColon > 1) {
			return oldPackageString.substring(lastIndexOfColon + 1);
		}
		return null;
	}

	def private String getPackageString(String data) {
		val int lastIndexOfColon = data.lastIndexOf(":");
		if (lastIndexOfColon > 1) {
			return data.substring(0, lastIndexOfColon - 1);
		}
		return null;
	}

	@Fix(ArchitectureAbstractionDSLValidator::NO_OBJECTS_REFERENCED_FOR_REGEXP)
	def public void addDotStarAtTheEndOfRegExp(Issue issue,
			IssueResolutionAcceptor acceptor) {
		val URI uri = issue.getUriToProblem();
		val ResourceSetImpl resourceSet = new ResourceSetImpl();
		try {
			val Resource r = resourceSet.createResource(uri);
//			ModelUtils::load(uri, resourceSet);
			r.load(null)
//			val Resource r = resourceSet.getResource(uri, false);
			val EObject eObj = r.getEObject(uri.fragment());

			if (eObj != null && eObj instanceof NameFilter) {
				val NameFilter nameFilter = eObj as NameFilter;
				if (!nameFilter.getRegEx().endsWith(".*")) {
					acceptor.accept(issue,
							"Add .* at the end of the regular expression",
							"Add .* at the end of the regular expression",
							"upcase.png",new AddStarModification(false,true));
				}
				if (!nameFilter.getRegEx().startsWith(".*")) {
					acceptor.accept(issue,
							"Add .* at the begin of the regular expression",
							"Add .* at the begin of the regular expression",
							"upcase.png", new AddStarModification(true,false));
				}
			}

		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
