package at.ac.univie.cs.swa.component.architectureabstraction.utils

import org.eclipse.emf.ecore.resource.Resource
import org.eclipse.emf.ecore.util.EcoreUtil$Copier

import at.ac.univie.cs.swa.component.architectureabstraction.architectureAbstractionDSL.AndComposition
import at.ac.univie.cs.swa.component.architectureabstraction.architectureAbstractionDSL.ArchitectureAbstractionDSLPackage
import at.ac.univie.cs.swa.component.architectureabstraction.architectureAbstractionDSL.ChildOfFilter
import at.ac.univie.cs.swa.component.architectureabstraction.architectureAbstractionDSL.ClassNameFilter
import at.ac.univie.cs.swa.component.architectureabstraction.architectureAbstractionDSL.ComponentDef
import at.ac.univie.cs.swa.component.architectureabstraction.architectureAbstractionDSL.ContainedInPackage
import at.ac.univie.cs.swa.component.architectureabstraction.architectureAbstractionDSL.ExcludeComposition
import at.ac.univie.cs.swa.component.architectureabstraction.architectureAbstractionDSL.Expression
import at.ac.univie.cs.swa.component.architectureabstraction.architectureAbstractionDSL.InstanceOf
import at.ac.univie.cs.swa.component.architectureabstraction.architectureAbstractionDSL.IsClass
import at.ac.univie.cs.swa.component.architectureabstraction.architectureAbstractionDSL.JavaExtensionFilter
import at.ac.univie.cs.swa.component.architectureabstraction.architectureAbstractionDSL.OrComposition
import at.ac.univie.cs.swa.component.architectureabstraction.architectureAbstractionDSL.PackageNameFilter
import at.ac.univie.cs.swa.component.architectureabstraction.architectureAbstractionDSL.Supertype
import at.ac.univie.cs.swa.component.architectureabstraction.architectureAbstractionDSL.Transformation
import at.ac.univie.cs.swa.component.architectureabstraction.architectureAbstractionDSL.UsedByFilter
import at.ac.univie.cs.swa.component.architectureabstraction.architectureAbstractionDSL.UsesFilter
import at.ac.univie.cs.swa.component.architectureabstraction.architectureAbstractionDSL.XtendExtensionFilter
import java.lang.reflect.Method
import java.util.HashSet
import java.util.LinkedList
import java.util.List
import java.util.Map
import java.util.Set
import org.eclipse.emf.common.util.URI
//import org.eclipse.emf.compare.utils.ModelUtils
import org.eclipse.emf.ecore.EObject
//import org.eclipse.uml2.uml.Class
import org.eclipse.uml2.uml.Classifier
import org.eclipse.uml2.uml.Component
import org.eclipse.uml2.uml.ComponentRealization
import org.eclipse.uml2.uml.Element
import org.eclipse.uml2.uml.Interface
import org.eclipse.uml2.uml.InterfaceRealization
import org.eclipse.uml2.uml.NamedElement
import org.eclipse.uml2.uml.Package
import org.eclipse.uml2.uml.PackageableElement
import org.eclipse.uml2.uml.Relationship
import org.eclipse.uml2.uml.UMLFactory
import org.eclipse.uml2.uml.Usage
import org.eclipse.xtext.resource.IEObjectDescription
import org.eclipse.xtext.scoping.IScope
import java.util.Collection
import org.eclipse.uml2.uml.Generalization
import at.ac.univie.cs.swa.component.architectureabstraction.architectureAbstractionDSL.SpecificInterface

class AssociationGeneratorEvaluator extends AbstractEvaluator {
	new () {
		
	}
	
	
	def dispatch Classifier wrap(Classifier ne) {
		return new ClassifierWrapper(ne);
	}
	
	def dispatch  org.eclipse.uml2.uml.Class wrap( org.eclipse.uml2.uml.Class ne) {
		return new ClassWrapper(ne);
	}

	def private Collection<? extends Classifier> wrapAll(Collection<? extends Classifier> collection) {
		val Collection<Classifier> list = new LinkedList
		for(Classifier ne : collection) {
			list.add(wrap(ne));
		}
		return list;
		
	}	
	
	protected var Resource myresource = null;
	
//	private var boolean createCopyOfClassModel = true;

	def getResource() {
		return myresource
	}
	
	override transform(Transformation trans, URI uri) {
		if(myresource != null) {
			cacheDirty()
		}
		myresource = trans.eResource.resourceSet.getResource(uri,false)
		if(myresource == null) {
//			myresource = trans.eResource.resourceSet.createResource(uri)
			var r = new MyUMLResource(uri)
			r.setUseIDAttribues(true)
			r.setUseUUIDs(false)			
			myresource = r 	
		}
		val model = UMLFactory::eINSTANCE.createModel
		model.setName("Component Model")

//		val Package rootPackage = XtendUtils::createPackage("root");
//		model.packagedElements.add(rootPackage)
		val Component comp = XtendUtils::createComponent(trans.name.replaceAll("\\s","").replaceAll("\\.","_"),
					model);			
		myresource.contents.add(model)

		//		val umleobjects = DSLEvaluator::cache.values.flatten
		//		val obj = umleobjects.head
		val List<ComponentDef> componentList = trans.getComponents();
		val Map<ComponentDef, Component> componentMap = createDefinedComponents(comp, componentList);
		createConnectors(comp,componentMap);

//		myresource.contents.add(classModel)

		//		val realizations = rootPackage.allOwnedElements.filter(typeof(Component)).map[e|e.realizations].flatten.toList
		//		fixRealizations(realizations, copier)
		return myresource
	}

	def fixRealizations(List<ComponentRealization> realizations, Copier res) {
		realizations.forEach[e|e.fixRealization(res)]
	}

	def fixRealization(ComponentRealization realization, Copier res) {
		val oldclassifiers = new LinkedList(realization.realizingClassifiers)
		realization.realizingClassifiers.clear
		realization.clients.clear
		realization.realizingClassifiers.empty
		for (Classifier old : oldclassifiers) {
			val newClassifier = findClonedClassifier(old, res)
			realization.realizingClassifiers.add(newClassifier)
			realization.clients.add(newClassifier)
		}
	}

	def Classifier findClonedClassifier(Classifier old, Copier c) {
		return c.get(old) as Classifier
	}

	override Set<Classifier> checkExpression(Expression expr) {
		var Set<Classifier> elements = null;
		if (getCache().containsKey(expr)) {
			elements = getCache().get(expr);
		} else {
			elements = expr.evaluateExpression();
		}

		return elements;

	}

	def dispatch Set<Classifier> evaluateExpression(Expression expression) {
		emptySet
	}

	def dispatch Set<Classifier> evaluateExpression(OrComposition expr) {
		val Expression left = expr.getLeft();
		val Expression right = expr.getRight();
		val Set<Classifier> matchedObjects = new HashSet<Classifier>();
		if (left != null && right != null) {
			matchedObjects.addAll(checkExpression(left));
			matchedObjects.addAll(checkExpression(right));
		}

		getCache().put(expr, matchedObjects);
		return matchedObjects;

	}

	def dispatch Set<Classifier> evaluateExpression(ExcludeComposition expr) {
		val Expression left = expr.getLeft();
		val Expression right = expr.getRight();
		val Set<Classifier> matchedObjects = new HashSet();
		if (left != null && right != null) {
			val Set<Classifier> elements = new HashSet();

			val Set<Classifier> resultLeft = checkExpression(left);
			val Set<Classifier> resultRight = checkExpression(right);

			elements.addAll(resultLeft);
			elements.removeAll(resultRight);
			matchedObjects.addAll(elements);
		}
		getCache().put(expr, matchedObjects);
		return matchedObjects;

	}

	def dispatch Set<Classifier> evaluateExpression(AndComposition expr) {
		val Expression left = expr.getLeft();
		val Expression right = expr.getRight();
		val Set<Classifier> matchedObjects = new HashSet();
		if (left != null && right != null) {
			val Set<Classifier> elements = new HashSet();

			val Set<Classifier> resultLeft = checkExpression(left);
			val Set<Classifier> resultRight = checkExpression(right);

			elements.addAll(resultLeft);
			elements.retainAll(resultRight);
			matchedObjects.addAll(elements);
		}

		getCache().put(expr, matchedObjects);
		return matchedObjects;
	}

	def dispatch Set<Classifier> evaluateExpression(JavaExtensionFilter expr) {

		val Set<Classifier> resultSet = new HashSet();
		val String classAndMethod = expr.getStaticMethod();
		val int dotIndex = classAndMethod.lastIndexOf(".");
		val String className = classAndMethod.substring(0, dotIndex - 1);
		val String methodName = classAndMethod.substring(dotIndex);
//		val java.lang.Class x = "".class
		try {
			val java.lang.Class<?> clasz = Class::forName(className)
			val Method m = clasz.getMethod(methodName, typeof(JavaExtensionFilter), typeof(List));
			val IScope scope = scopeProvider.getScope(expr,
				ArchitectureAbstractionDSLPackage::eINSTANCE.getUsesFilter_RelatedTo());
			val Object result = m.invoke(null, expr, scope.getAllElements());
			if (result instanceof List<?>) {
				val List<Classifier> classifiers = result as List<Classifier>;
				resultSet.addAll(wrapAll(classifiers));
			}

		} catch (Exception e) {
			e.printStackTrace();
		}
		getCache().put(expr, resultSet);
		return resultSet;

	}

	def dispatch Set<Classifier> evaluateExpression(XtendExtensionFilter expr) {
		val Set<Classifier> hashSet = new HashSet<Classifier>();
		hashSet.addAll(wrapAll(checkReferencedItems(expr)));
		getCache().put(expr, hashSet);

		return hashSet;
	}

	def dispatch Set<Classifier> evaluateExpression(PackageNameFilter expr) {
		val IScope scope = scopeProvider.getScope(expr,
			ArchitectureAbstractionDSLPackage::eINSTANCE.getContainedInPackage_RelatedTo());
		val String regExp = expr.getRegEx();
		val Set<Classifier> matchedObjects = new HashSet<Classifier>();
		if (regExp != null) {
			val Iterable<IEObjectDescription> allElements = scope.getAllElements();
			for (IEObjectDescription eObjDescr : allElements) {
				if (eObjDescr.getName().toString().matches(regExp)) {
					var EObject eObjectOrProxy = eObjDescr.getEObjectOrProxy();
					if (eObjectOrProxy instanceof Package) {
						eObjectOrProxy = checkAndResolveProxy(expr, eObjectOrProxy);
						val Package namedElement = eObjectOrProxy as Package;
						val List<Element> ownedElements = namedElement.getOwnedElements();
						for (Element element : ownedElements) {
							if (element instanceof Classifier) {
								val Classifier clasz = element as Classifier;
								matchedObjects.add(wrap(clasz));
							}
						}
					}
				}

			}

		}

		getCache().put(expr, matchedObjects);
		return matchedObjects;

	}

	def dispatch Set<Classifier> evaluateExpression(ContainedInPackage expr) {
		val Package packag = expr.getRelatedTo();
		val Set<Classifier> matchedObjects = new HashSet();
		addAllOwnedElements(packag, matchedObjects, expr.isExcludeChildren());

		getCache().put(expr, matchedObjects);
		return matchedObjects;

	}

	def private void addAllOwnedElements(Package packag, Set<Classifier> matchedObjects, boolean excludeChildren) {
		if (packag != null) {
			val List<PackageableElement> ownedElements = packag.getPackagedElements();
			for (Element element : ownedElements) {
				if (element instanceof Classifier) {
					val Classifier clasz = element as Classifier;
					matchedObjects.add(wrap(clasz));
				}
				if (element instanceof Package && !excludeChildren) {
					addAllOwnedElements(element as Package, matchedObjects, excludeChildren);
				}
			}

		}
	}

	def dispatch Set<Classifier> evaluateExpression(IsClass expr) {
		var org.eclipse.uml2.uml.Class clasz = expr.getRelatedTo();
		val Set<Classifier> matchedObjects = new HashSet();
		if (clasz != null) {
			clasz = (checkAndResolveProxy(expr, clasz) as org.eclipse.uml2.uml.Class);
			matchedObjects.add(wrap(clasz));
		}

		getCache().put(expr, matchedObjects);
		return matchedObjects;

	}

	def dispatch Set<Classifier> evaluateExpression(ClassNameFilter expr) {
		val IScope scope = scopeProvider.getScope(expr,
			ArchitectureAbstractionDSLPackage::eINSTANCE.getIsClass_RelatedTo());
		val String regExp = expr.getRegEx();
		val Set<Classifier> matchedObjects = new HashSet();
		if (regExp != null) {
			val Iterable<IEObjectDescription> allElements = scope.getAllElements();
			for (IEObjectDescription eObjDescr : allElements) {
				if (eObjDescr.getName().toString().matches(regExp)) {
					var EObject eObjectOrProxy = eObjDescr.getEObjectOrProxy();
					if (eObjectOrProxy instanceof org.eclipse.uml2.uml.Class) {
						eObjectOrProxy = checkAndResolveProxy(expr, eObjectOrProxy);

						val Classifier namedElement = eObjectOrProxy as Classifier;
						matchedObjects.add(wrap(namedElement));
					}
				}

			}

		}

		getCache().put(expr, matchedObjects);
		return matchedObjects;

	}

	def dispatch Set<Classifier> evaluateExpression(UsedByFilter expr) {
		val Classifier classifier = expr.getRelatedTo();
		val Set<Classifier> matchedObjects = new HashSet();
		if (classifier != null) {
			val List<Relationship> relationShips = classifier.getRelationships();
			for (Relationship r : relationShips) {
				if (r instanceof Usage) {
					val Usage ur = r as Usage;
					if (ur.getClients().contains(classifier)) {
						val List<NamedElement> suppliers = ur.getSuppliers();
						for (NamedElement ne : suppliers) {
							if (ne instanceof Classifier) {
								val Classifier supplier = ne as Classifier;
								matchedObjects.add(wrap(supplier));
							}
						}
					}
				}
			}
		}

		getCache().put(expr, matchedObjects);
		return matchedObjects;
	}

	def dispatch Set<Classifier> evaluateExpression(UsesFilter expr) {
		val Classifier classifier = expr.getRelatedTo();
		val Set<Classifier> matchedObjects = new HashSet();
		if (classifier != null) {
			val List<Relationship> relationShips = classifier.getRelationships();
			for (Relationship r : relationShips) {
				if (r instanceof Usage) {
					val Usage ur = r as Usage;
					if (ur.getSuppliers().contains(classifier)) {
						val List<NamedElement> clients = ur.getClients();
						for (NamedElement ne : clients) {
							if (ne instanceof Classifier) {
								val Classifier client = ne as Classifier;
								matchedObjects.add(wrap(client));
							}
						}
					}
				}
			}
		}

		getCache().put(expr, matchedObjects);
		return matchedObjects;

	}

	def dispatch Set<Classifier> evaluateExpression(ChildOfFilter expr) {
//		val IScope scope = scopeProvider.getScope(expr,
//			ArchitectureAbstractionDSLPackage::eINSTANCE.getChildOfFilter_RelatedTo());
		val Set<Classifier> matchedObjects = new HashSet();
		val org.eclipse.uml2.uml.Class superclasz = expr.getRelatedTo();
		matchedObjects.addAll(wrapAll(superclasz.allChildClassifier))
//TODO improve this
				
//		val Set<Classifier> matchedObjects = new HashSet();
//		if (superclasz != null) {
//			val Iterable<IEObjectDescription> allElements = scope.getAllElements();
//			for (IEObjectDescription eObjDescr : allElements) {
//				var EObject eObj = eObjDescr.getEObjectOrProxy();
//				eObj = checkAndResolveProxy(expr, eObj);
//				if (eObj instanceof org.eclipse.uml2.uml.Class) {
//					val org.eclipse.uml2.uml.Class clasz = eObj as org.eclipse.uml2.uml.Class;
//					if (clasz.getSuperClasses().contains(superclasz)) {
//						matchedObjects.add(wrap(clasz));
//					}
//				}
//			}
//
//		}

		getCache().put(expr, matchedObjects);
		return matchedObjects;

	}

	def dispatch Set<Classifier> evaluateExpression(Supertype expr) {
		val org.eclipse.uml2.uml.Class clasz = expr.getRelatedTo();
		val Set<Classifier> matchedObjects = new HashSet<Classifier>();
		if (clasz != null) {
			matchedObjects.addAll(wrapAll(clasz.getSuperClasses()));
		}

		getCache().put(expr, matchedObjects);
		return matchedObjects;
	}

	def dispatch Set<Classifier> evaluateExpression(SpecificInterface expr) {
		val Set<Classifier> matchedObjects = new HashSet<Classifier>();	
		val Interface inter = expr.getRelatedTo();
				
		if (inter != null) {
			matchedObjects.add(wrap(inter));
		}

		getCache().put(expr, matchedObjects);
		return matchedObjects;
	}
	

	def dispatch Set<Classifier> evaluateExpression(InstanceOf expr) {
		val Set<Classifier> matchedObjects = new HashSet<Classifier>();	
		val Interface inter = expr.getRelatedTo();
		if(!expr.excludeInterface) {
			matchedObjects.add(wrap(inter));
		}		
		if (inter != null) {
//			val List<Relationship> relationShips = inter.getRelationships();
			for(ir : inter.allInterfaceRealizations) {
				matchedObjects.add(wrap(ir.getImplementingClassifier()));
			}
//			for (Relationship r : relationShips) {
//				if (r instanceof InterfaceRealization) {
//					val InterfaceRealization ir = r as InterfaceRealization;
//					matchedObjects.add(wrap(ir.getImplementingClassifier()));
//				}
//			}
		}

		getCache().put(expr, matchedObjects);
		return matchedObjects;
	}
	
	def Set<InterfaceRealization> getAllInterfaceRealizations(Interface inter) {
		val set = new HashSet
		val childInterfaces = inter.allChildClassifier.filter(typeof(Interface))
		set.addAll(inter.interfaceRealizations)
		set.addAll(childInterfaces.map(ci|ci.interfaceRealizations).flatten)
		return set
	}
	
	def Set<InterfaceRealization> getInterfaceRealizations(Interface inter) {
		return inter.relationships.filter(typeof(InterfaceRealization)).toSet
	}
	
//	def Set<Interface> getAllChildInterfaces(Interface inter) {
//		val set = new HashSet
////		val test = inter.getTargetDirectedRelationships(UMLFactory::eINSTANCE.createGeneralization.eClass);
////		val List<? extends Relationship> relationShips = inter.relationships.filter(typeof(Generalization)).toList;
//		val generalizations = inter.targetDirectedRelationships.filter(typeof(Generalization));
////		val filteredGeneralizations = generalizations.filter(g| g.general.equals(inter)).filterNull
//		val directChildInterfaces = generalizations.map[e|e.specific].filter(typeof(Interface))
//		set.addAll(directChildInterfaces)
//		set.addAll(directChildInterfaces.map(ci| ci.allChildInterfaces).flatten)
//		return set
//	}

def Set<Classifier> getAllChildClassifier(Classifier inter) {
		val set = new HashSet
//		val test = inter.getTargetDirectedRelationships(UMLFactory::eINSTANCE.createGeneralization.eClass);
//		val List<? extends Relationship> relationShips = inter.relationships.filter(typeof(Generalization)).toList;
		val generalizations = inter.targetDirectedRelationships.filter(typeof(Generalization));
//		val filteredGeneralizations = generalizations.filter(g| g.general.equals(inter)).filterNull
		val directChildInterfaces = generalizations.map[e|e.specific].filter(typeof(Classifier))
		set.addAll(directChildInterfaces)
		set.addAll(directChildInterfaces.map(ci| ci.allChildClassifier).flatten)
		return set
	}	
}