package at.ac.univie.cs.swa.component.architectureabstraction.utils

import java.util.List
import org.eclipse.emf.ecore.resource.Resource
import org.eclipse.emf.ecore.util.EcoreUtil
import org.eclipse.emf.ecore.util.EcoreUtil$Copier
import org.eclipse.uml2.uml.Classifier
import org.eclipse.uml2.uml.Model
import org.eclipse.uml2.uml.PackageableElement
import org.eclipse.uml2.uml.UMLFactory
import org.eclipse.xtext.EcoreUtil2

class DSLEvaluator extends AssociationGeneratorEvaluator {

	new() {
		
	}

	private var copier = new Copier

	private var Model classModel = null;
	
	override public void cacheDirty() {
		super.cacheDirty
		this.classModel = null
		copier = new Copier
	}

	override  Classifier wrap(Classifier ne) {		
		copyClassModel(ne.eResource());		
		val Classifier newClassifier = getCopyOf(ne);
		if(newClassifier == null) {
			println("could not find copy for classifier: " + ne);
			return ne;
		}
		return new ClassifierWrapper(newClassifier);
	}
	

	def getCopyOf(Classifier c) {
//		if(!createCopyOfClassModel) {
//			return c;
//		}
		if(copier == null) {
			throw new RuntimeException("No copier found!");
		}
		if(c.eIsProxy) {
			EcoreUtil2::resolveAll(c)
		}
		if(c.eResource == null || c.eResource.equals(resource)) {
			return c
		}
		return copier.get(c) as Classifier;
	
	}

	def void copyClassModel(Resource r) {
		if(classModel != null && resource != null) {
			return	
		}
		EcoreUtil::resolveAll(r)
		classModel = UMLFactory::eINSTANCE.createModel
		classModel.setName("Class Model")

		//  		myresource.contents.add(classModel)
		val contents = r.contents

		val List<PackageableElement> filteredContents = contents.filter(typeof(PackageableElement)).toList

		//  		.filter(e| e instanceof Element).toList as List<Element>
		val copies = copier.copyAll(filteredContents)
		copier.copyReferences
		classModel.packagedElements.addAll(copies)
		myresource.contents.add(classModel)
	}


}
