package at.ac.univie.cs.swa.component.architectureabstraction.utils

import at.ac.univie.cs.swa.component.architectureabstraction.architectureAbstractionDSL.ComponentDef
import at.ac.univie.cs.swa.component.architectureabstraction.architectureAbstractionDSL.GroupingAnnotation
import at.ac.univie.cs.swa.component.architectureabstraction.architectureAbstractionDSL.PatternInstancePrimitiveTarget
import at.ac.univie.cs.swa.component.architectureabstraction.architectureAbstractionDSL.PrimitiveAnnotation
import at.ac.univie.cs.swa.pattern.catalog.patternCatalogDSL.Grouping
import at.ac.univie.cs.swa.pattern.catalog.patternCatalogDSL.Layering
import at.ac.univie.cs.swa.pattern.catalog.patternCatalogDSL.Primitive
import java.util.LinkedList
import java.util.List
import java.util.Map
import org.eclipse.emf.ecore.EObject
import org.eclipse.emf.ecore.util.EcoreUtil$EqualityHelper

class RangeCheckUtilitiesXtend {
	val equalityHelper = new EqualityHelper
	extension ArchitectureAbstractionUtils utils = new ArchitectureAbstractionUtils
	
	def myequals(EObject eObj, EObject eObj2) {
		return equalityHelper.equals(eObj,eObj2)
	}
	
	def dispatch hasGroupProperty(Primitive p) {
		return false
	}
	
	def dispatch hasGroupProperty(Grouping g) {
		return true
	}
	
	def dispatch hasGroupProperty(Layering g) {
		return true
	}
	
	
//	def void checkAnnotations(Primitive primitive,
//			Map<String, List<ComponentDef>> groups, ComponentDef compDef,
//			List<PrimitiveAnnotation> annotations) {
//		for (PrimitiveAnnotation annotation : annotations) {
//			if (annotation.getPrimitive().equals(primitive)) {
//				checkProperties(groups, compDef,annotation);
//			}
//		}
//	}

	def dispatch void checkProperties(Map<String, List<ComponentDef>> groups,
			ComponentDef compDef, PrimitiveAnnotation annotation) {
//		var boolean assigned = false;
//		for (PropertyValue propValue : annotationproperties) {
//			if (propValue.getProperty().getName().toLowerCase().equals(RangeCheckUtilities::GROUPID)) {
//				val String groupId = propValue.getValue();
//				addComponentToGroup(groups, compDef, groupId);
//				assigned = true;
//				break;
//			}
//
//		}
//		if (!assigned) {
			addComponentToGroup(groups, compDef, RangeCheckUtilities::UNASSIGNED_GROUP);
//		}
	}
	
	def dispatch void  checkProperties(Map<String, List<ComponentDef>> groups,
			ComponentDef compDef, GroupingAnnotation annotation) {
				val groupId = annotation.groupID
				if(groupId != null) { 
					addComponentToGroup(groups, compDef, groupId)
				} else {
					addComponentToGroup(groups, compDef, RangeCheckUtilities::UNASSIGNED_GROUP) 
				}
			}			
	
	def private void addComponentToGroup(
			Map<String, List<ComponentDef>> groups, ComponentDef compDef,
			String groupid) {
		if (groups.containsKey(groupid)) {
			groups.get(groupid).add(compDef);
		} else {
			var List<ComponentDef> grouped = new LinkedList<ComponentDef>();
			grouped.add(compDef);
			groups.put(groupid, grouped);
		}
	}

	def String getGroupID(PatternInstancePrimitiveTarget target, Primitive primitive) {
		if(target != null)
			return getGroupIDInternal(target,primitive)
		return "unknown"
	}
	
	def dispatch String getGroupIDInternal(ComponentDef target, Primitive primitive) {
					val primitiveannotation = target?.annotations.findFirst(e|e.matches(primitive))
					if(primitiveannotation == null) {
						println("no primitive annotation found - null")
						return null
						}
		return getGroupID(primitiveannotation)
	}
	
	def dispatch String getGroupIDInternal(GroupingAnnotation target, Primitive primitive) {
		return target?.groupID
	}
	
	def dispatch String getGroupIDInternal(PatternInstancePrimitiveTarget target, Primitive primitive) {
		
	}
	
	def dispatch String getGroupID(PrimitiveAnnotation annotation) {
		
	}
	
	def dispatch String getGroupID(GroupingAnnotation annotation) {
		annotation?.groupId
	} 
}